program KeyboardInput;

{$mode objfpc}{$H+}

{Declare some units used by this example.}
uses
  GlobalConst,
  GlobalTypes,
  Platform,
  Threads,
  Console,
  Framebuffer,
  BCM2835,
  BCM2708,
  SysUtils,
  Keyboard, {Keyboard uses USB so that will be included automatically}
  DWCOTG;   {We need to include the USB host driver for the Raspberry Pi}

{We'll need a window handle again.}
var
 WindowHandle:TWindowHandle;





procedure KeyboardTest;
var
 Count:LongWord;
 KeyboardData:TKeyboardData;
begin

 if KeyboardRead(@KeyboardData,SizeOf(KeyboardData),Count) = ERROR_SUCCESS then
  begin

    WriteLn('KeyboardData.KeyCode   = ' + IntToHex(KeyboardData.KeyCode,4));
    WriteLn('KeyboardData.Modifiers = ' + IntToHex(KeyboardData.Modifiers,4));
    WriteLn('KeyboardData.ScanCode  = ' + IntToHex(KeyboardData.ScanCode,4));
    WriteLn(' ');

  end;


end; { procedure KeyboardTest }





begin
 {Create a console window at full size}
 WindowHandle:=ConsoleWindowCreate(ConsoleDeviceGetDefault,CONSOLE_POSITION_FULL,True);

 {Output some welcome text on the console window}
 ConsoleWindowWriteLn(WindowHandle,'Welcome to Example 04 Keyboard Input');
 ConsoleWindowWriteLn(WindowHandle,'Make sure you have a USB keyboard connected and start typing some characters');


 while true do begin

   KeyboardTest;

 end;



end.

